(in-package #:org.shirakumo.fraf.mixed.examples)

(defun tone-frequency (tone)
  (ecase tone
    (_    0.0)
    (C4   261.63)
    ( C#4 277.18)
    (D4   293.66)
    ( D#4 311.13)
    (E4   329.63)
    (F4   349.23)
    ( F#4 369.99)
    (G4   392.00)
    ( G#4 415.30)
    (A4   440.00)
    ( A#4 466.16)
    (B4   493.88)
    (C5   523.25)
    ( C#5 554.37)
    (D5   587.33)
    ( D#5 622.25)
    (E5   659.25)
    (F5   698.46)))

(defun tone (tones &key (type :sine) (samplerate 44100) (output 'org.shirakumo.fraf.mixed.out123:drain))
  (let ((tones (loop for (tone length) in tones
                     collect (list (find-symbol (string tone) #.*package*) length))))
    (mixed:with-objects ((generator (mixed:make-generator :type type :samplerate samplerate))
                         (distributor (mixed:make-distributor))
                         (drain (mixed:make-packer :samplerate samplerate))
                         (out (make-instance output :pack drain)))
      (mixed:with-buffers 500 (mono)
        (mixed:connect generator :mono distributor 0 mono)
        (dotimes (i 2)
          (mixed:connect distributor i drain i NIL))
        (mixed:with-chain chain (generator distributor drain out)
          (loop with time = 0.0
                for (tone duration) = (first tones)
                while tones
                do (setf (mixed:frequency generator) (tone-frequency tone))
                   (mixed:mix)
                   (when (<= duration time)
                     (decf time duration)
                     (pop tones))))))))
